exercises/relations/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # BEGIN
  
  # END
  resources :tasks, :statuses, :users
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'home#index'
end

exercises/relations/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/relations/app/models/status.rb
# frozen_string_literal: true

class Status < ApplicationRecord
  # BEGIN
  
  # END
end

exercises/relations/app/models/task.rb
class Task < ApplicationRecord
  belongs_to :status
  belongs_to :user
end

exercises/relations/app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  # BEGIN
  has_many :tasks
  # END
end

exercises/relations/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/relations/app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end
end

exercises/relations/app/controllers/statuses_controller.rb
# frozen_string_literal: true

class StatusesController < ApplicationController
  def index
    @statuses = Status.all
  end

  def show
    @status = Status.find params[:id]
  end

  def new
    @status = Status.new
  end

  def edit
    @status = Status.find params[:id]
  end

  def create
    @status = Status.new(status_params)

    if @status.save
      redirect_to @status, notice: 'Status was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    @status = Status.find params[:id]

    if @status.update(status_params)
      redirect_to @status, notice: 'Status was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @status = Status.find params[:id]

    @status.destroy

    redirect_to statuses_url, notice: 'Status was successfully destroyed.'
  end

  private

  # Only allow a list of trusted parameters through.
  def status_params
    params.require(:status).permit(:name)
  end
end

exercises/relations/app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  def index
    @tasks = Task.all
  end

  def show
    @task = Task.find params[:id]
    # Task.preload(:status)
  end

  def new
    @task = Task.new
  end

  def edit
    @task = Task.find params[:id]
  end

  def create
    # debugger
    @task = Task.new(task_params)

    if @task.save
      redirect_to @task, notice: 'Task was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    @task = Task.find params[:id]

    if @task.update(task_params)
      redirect_to @task, notice: 'Task was successfully created.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def task_params
    params.require(:task).permit(:name, :description, :creator, :performer, :completed, :status_id, :user_id)
  end
end

exercises/relations/app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  def index
    @users = User.all
  end

  def show
    @user = User.find params[:id]
    @tasks = @user.tasks
    @statuses = Status.all
  end

  def new
    @user = User.new
  end

  def edit
    @user = User.find params[:id]
  end

  def create
    @user = User.new(user_params)

    if @user.save
      redirect_to @user, notice: 'User was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    @user = User.find params[:id]

    if @user.update(user_params)
      redirect_to @user, notice: 'User was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @user = User.find params[:id]

    @user.destroy

    redirect_to users_url, notice: 'User was successfully destroyed.'
  end

  private

  # Only allow a list of trusted parameters through.
  def user_params
    params.require(:user).permit(:name)
  end
end

exercises/relations/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/relations/app/helpers/tasks_helper.rb
module TasksHelper
end

exercises/relations/app/views/layouts/shared/_flash.html.slim
- if flash.any?
  .container.my-2
    - flash.each do |_type, msg|
      .alert.alert-info
        = msg

exercises/relations/app/views/layouts/shared/_nav.html.slim
.navbar.navbar-expand-md.navbar-light
  a.navbar-brand.me-md-4(href='/')
    = image_tag asset_pack_path('media/images/logo.png'), width: 30, alt: t('.hexlet_logo')

  #navbarToggler.collapse.navbar-collapse
    ul.nav.nav-pills.flex-grow-1.navbar-nav
      li.nav-item.me-2
        = link_to 'Home', root_path, class: 'nav-link link-dark'
      li.nav-item.me-2
        = link_to 'Tasks', tasks_path, class: 'nav-link link-dark'
      li.nav-item.me-2
         = link_to 'Statuses', statuses_path, class: 'nav-link link-dark'
      li.nav-item.me-2
        = link_to 'Users', users_path, class: 'nav-link link-dark'

exercises/relations/app/views/tasks/_form.html.slim
= simple_form_for(@task) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :name
  = f.input :description
  = f.association :status
  = f.collection_select :user_id, User.all, :id, :name
  = f.input :performer
  = f.input :completed

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/relations/app/views/tasks/edit.html.slim
= content_for :title do
  = 'Editing task'

== render 'form'

hr

.d-flex
  = link_to 'Show', @user, class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/relations/app/views/tasks/index.html.slim
= content_for :titme do
  = 'Tasks'

table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } #
      th{ scope: :col } Name
      th{ scope: :col } Description
      th{ scope: :col } Status
      th{ scope: :col } Performer
      th{ scope: :col } Completed
      th

  tbody
    - @tasks.each_with_index do |task, i|
      tr
        th{ scope: :col } = i + 1
        th = task.name
        th = task.description
        th = @statuses.find(task.status_id).name
        th = task.performer
        th = task.completed
        th.d-flex
          .me-4 = link_to 'Show', task
          .me-4 = link_to 'Edit', edit_task_path(task)
          = link_to 'Destroy', task, data: { confirm: 'Are you sure?' }, methor: :delete

= link_to 'New task', new_task_path, class: 'btn btn-primary'

exercises/relations/app/views/tasks/new.html.slim
= content_for :title do
  = 'New task'

== render 'form'

hr

= link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/relations/app/views/tasks/show.html.slim
= content_for :title do
  = @task.name

p = @task.description
p
  span.badge.bg-secondary = @task.status.name
/ p
/   span.fst-italic = @task.creator

hr

.d-flex
  = link_to 'Edit', edit_task_path(@task), class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'